#pragma once

#ifdef [!output CHANNEL_EXPORTS]
#define [!output CHANNEL_NAME_DEFINE]_API __declspec(dllexport)
#else
#define [!output CHANNEL_NAME_DEFINE]_API __declspec(dllimport)
#endif

[!output CHANNEL_ADDITIONAL_HEADER]
[!output CHANNEL_BASECLASS_HEADER]

#define [!output CHANNEL_NAME_DEFINE]_NAME		"[!output CHANNEL_NAME]"
#define [!output CHANNEL_NAME_DEFINE]_VERSION		1

//[!output CHANNEL_GUID_COMMENT]
static const GUID [!output CHANNEL_NAME_DEFINE]_GUID = [!output CHANNEL_GUID_STRUCT];

class [!output CHANNEL_NAME_DEFINE]_API [!output CHANNEL_NAME]: public [!output CHANNEL_BASE_CLASS]
{
public:
	[!output CHANNEL_NAME]();
	virtual ~[!output CHANNEL_NAME]();

	
	// Save persistent channel data in channel group
	virtual bool			SaveChannel(A3dFileSaver& saver);
	// Load persistent channel data from channel group
	virtual bool			LoadChannel(A3dFileLoader& loader, A3d_ChannelGroup *group);

	// Add needed dependencies for publishing
	virtual void			DoDependencyInit(A3d_List* currentDependList);

	//CallChannel function invoked by the engine
	virtual void 			CallChannel();
protected:

};

// Leave rest of header file intact!
#define [!output CHANNEL_NAME_DEFINE]DLL_EXPORTS extern "C" { \
__declspec(dllexport) DllInterface * __cdecl InitDLL() \
{ \
	return new [!output CHANNEL_NAME]; \
} \
}

